SystemOrganization addCategory: #'PBE-LightsOut'!

SimpleSwitchMorph subclass: #LOCell
	instanceVariableNames: 'mouseAction lClick'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOCell methodsFor: 'as yet unclassified' stamp: 'alexz 9/22/2012 16:11'!
initialize 
	super initialize.
	self label: ''.
	self  borderWidth: 2.
	bounds := 0@0 corner: 32@32.
	offColor := Color paleYellow.
	onColor := Color paleGreen  darker.
	self turnOn ! !

!LOCell methodsFor: 'accessing' stamp: 'alexz 9/19/2012 21:24'!
mouseAction: aBlock
	^ mouseAction := aBlock! !

!LOCell methodsFor: 'as yet unclassified' stamp: 'alexz 9/30/2012 08:08'!
mouseDown: evt
	lClick := evt redButtonPressed! !

!LOCell methodsFor: 'as yet unclassified' stamp: 'alexz 9/30/2012 08:08'!
mouseUp: anEvent
	 mouseAction value: lClick ! !

BorderedMorph subclass: #LOGame
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOGame methodsFor: 'as yet unclassified' stamp: 'DDC 10/1/2012 07:52'!
cells
	^cells ! !

!LOGame methodsFor: 'as yet unclassified' stamp: 'alexz 9/19/2012 19:02'!
cellsPerSide
	"El nmero de celdas a lo largo de cada lado del juego"
	^ 10! !

!LOGame methodsFor: 'as yet unclassified' stamp: 'alexz 9/30/2012 08:03'!
initialize
	| sampleCell width height n |
	super initialize.
	n := self cellsPerSide.
	sampleCell := LOCell new.
	width := sampleCell width.
	height := sampleCell height.
	self bounds: (5@5 extent: ((width*n) @(height*n)) + (2*self borderWidth)).
	cells := Matrix new: n tabulate: [ :i :j | self newCellAt: i at: j ].
	self openInWorld 
! !

!LOGame methodsFor: 'as yet unclassified' stamp: 'alexz 9/20/2012 09:19'!
mouseMove: anEvent	! !

!LOGame methodsFor: 'as yet unclassified' stamp: 'alexz 9/30/2012 18:14'!
newCellAt: i at: j
	"Creacin de una celda para la posicin (i, j) y la aade en pantalla en la posicin adecuada. Retorna 	la nueva celda "
	| c origin |
	c := LOCell new.
	origin := self innerBounds origin.
	self addMorph: c.
	c position: ((i - 1)*c width) @ ((j - 1)*c height) + origin.
	c mouseAction: [ :lClick| lClick 
		ifTrue: [self toggleNeighboursOfCellAt: i at: j] 
		ifFalse: [self toggleDiagonalNeighboursOfCellAt: i  at:j ]].
	^c

! !

!LOGame methodsFor: 'game logic' stamp: 'DDC 9/21/2012 21:27'!
toggleDiagonalNeighboursOfCellAt: i at: j
   ((i > 1) & (j > 1)) ifTrue: [ (cells at: i - 1 at: j - 1) toggleState].
   ((i < self cellsPerSide) & (j < self cellsPerSide)) ifTrue: [ (cells at: i + 1 at: j + 1) toggleState].
   ((i < self cellsPerSide) & (j > 1)) ifTrue: [ (cells at: i + 1  at: j - 1) toggleState].
   ((i > 1) & (j < self cellsPerSide)) ifTrue: [ (cells at: i - 1 at: j + 1) toggleState].! !

!LOGame methodsFor: 'game logic' stamp: 'alexz 9/20/2012 06:05'!
toggleNeighboursOfCellAt: i at: j
   (i > 1) ifTrue: [ (cells at: i - 1 at: j ) toggleState].
   (i < self cellsPerSide) ifTrue: [ (cells at: i + 1 at: j) toggleState].
   (j > 1) ifTrue: [ (cells at: i  at: j - 1) toggleState].
   (j < self cellsPerSide) ifTrue: [ (cells at: i at: j + 1) toggleState].! !

TestCase subclass: #LOGameTest
	instanceVariableNames: 'juego'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOGameTest methodsFor: 'as yet unclassified' stamp: 'DDC 10/1/2012 07:59'!
cuentaCuadradosDiagonales: i at: j
	|cont bloque|	
	cont := 0.	
	bloque := [ :l :k :s | ((s cells at: l at: k) isOn) ifTrue: [cont := cont+1] ]. 
 	((i > 1) & (j > 1)) ifTrue: [ bloque value: i value: j value: juego  ].
	((i < juego  cellsPerSide) & (j < juego  cellsPerSide)) ifTrue: [  bloque value: i value: j value: juego  ].
	((i < juego  cellsPerSide) & (j > 1)) ifTrue: [  bloque value: i value: j value: juego  ].
 	((i > 1) & (j < juego  cellsPerSide)) ifTrue: [  bloque value: i value: j value: juego  ].
	^cont	! !

!LOGameTest methodsFor: 'as yet unclassified' stamp: 'alexz 9/30/2012 22:54'!
setUp 	
	"inicializamos algunas variables que necesita"
	juego := LOGame  new.
      ! !

!LOGameTest methodsFor: 'as yet unclassified' stamp: 'DDC 10/1/2012 08:00'!
testToggleDiagonalNeighboursOfCellAt
	"el test consistira en contar los cuadraditos diagonales que han cambiado de estado, respecto al cuadrado (i,j)"
	juego toggleDiagonalNeighboursOfCellAt: 2 at: 2. 	
	self assert: (self cuentaCuadradosDiagonales: 2 at: 2) = 4! !
